
/*
 * TOUCH_EVENT.c
 *
 *  Created on: 1/04/2014
 *      Author: Holguer A. Becerra
 *      Adrizcorp@gmail.com
 */

// INCLUDES TOUCH
#include <stdio.h>
#include <unistd.h>  // usleep (unix standard?)
#include "io.h" // I/O access
#include "system.h" // HAL system

#include "./touch_driver/TOUCH_EVENT.h"


#include "./Detect_button/boton.h"
// INCLUDES VIDEO


#include "terasic_includes.h"
#include "vip_fr.h"
#include "./graphic_lib/simple_graphics.h"
#include "./graphic_lib/gimp_bmp.h"
#include "./graphic_lib/draw_gimps.h"




#define FRAME_WIDTH  480
#define FRAME_HEIGHT 272


#define FR_FRAME_0  (SDRAM_BASE)
#define FR_FRAME_1  (SDRAM_BASE+FRAME_WIDTH*FRAME_HEIGHT*4)

#define CX_REG  0
#define CY_REG 1
#define MAX_ITR_REG 2
#define FRAC_START_REG 3
#define ITR_DATA_REG  0
#define ITR_FIELD 0x0000ffff
#define FRAC_READY_BIT 0x00010000





// vector de colores

unsigned int colors[80]={GREEN_24,AQUAMARINE_24,BROWN_24,BLUEVIOLET_24,INDIGO_24, LEMONCHIFFON_24,OLIVE_24,SILVER_24, DIMGRAY_24,GOLD_24,ALICEBLUE_24,ANTIQUEWHITE_24,AQUA_24 ,AQUAMARINE_24,AZURE_24 ,BEIGE_24 ,BISQUE_24 ,BLACK_24   ,BLANCHEDALMOND_24,BLUE_24  ,BLUEVIOLET_24,BROWN_24 ,BURLYWOOD_24 ,CADETBLUE_24 ,CHARTREUSE_24,CHOCOLATE_24 ,CORAL_24 ,CORNFLOWERBLUE_24,CORNSILK_24,CRIMSON_24 ,CYAN_24,DARKBLUE_24,DARKCYAN_24 ,DARKGOLDENROD_24,DARKGRAY_24 ,DARKGREEN_24 , DARKKHAKI_24 ,DARKMAGENTA_24 ,DARKOLIVEGREEN_24,DARKORANGE_24 ,DARKORCHID_24 ,DARKRED_24  ,DARKSALMON_24 ,DARKSEAGREEN_24, DARKSLATEBLUE_24  ,DARKSLATEGRAY_24,DARKSLATEGREY_24  ,DARKTURQUOISE_24,DARKVIOLET_24 ,DEEPPINK_24 ,DEEPSKYBLUE_24,DIMGRAY_24 ,DIMGREY_24  ,DODGERBLUE_24, FIREBRICK_24 ,FLORALWHITE_24 ,FORESTGREEN_24 ,FUCHSIA_24 ,GAINSBORO_24 ,GHOSTWHITE_24 ,GOLD_24,GOLDENROD_24,GRAY_24 ,GREY_24,GREEN_24,GREENYELLOW_24 ,HONEYDEW_24 ,HOTPINK_24 ,INDIANRED_24,INDIGO_24  ,IVORY_24 ,KHAKI_24  ,LAVENDER_24,LAVENDERBLUSH_24 , LAWNGREEN_24 ,LEMONCHIFFON_24};


typedef alt_32 fixed428;
typedef alt_64 fixed856;

int calc_frac_point_sw( fixed428 cx, fixed428 cy, alt_u16 max_itr)
{
    fixed428 x, y, xx, yy, xy2;
    fixed856 xx_raw, yy_raw, xy_raw;
    int itr;
    x = cx;
    y = cy;
    itr=0;
    do {
            /* Q4.Z8 multiplications */

                xx_raw= (fixed856)(x) * (fixed856)(x);

                xx = (fixed428)(xx_raw >> 28);

                yy_raw = (fixed856)(y) * (fixed856)(y);

                yy = (fixed428)(yy_raw >> 28);

                xy_raw=(fixed856)(x) * (fixed856)(y);

                xy2 = (fixed428)(xy_raw>>27); // 2* is same as 1

                /* iteration equation */

                x = xx - yy + cx;

                y =  xy2 + cy;

                itr++;

                } while (((xx+yy)<0x40000000) && ( itr < max_itr ) ) ;

       return(itr);

 }

// subfuncion calcular fractal
	int calc_frac_point_hw( fixed428 cx, fixed428 cy, alt_u16 max_itr)
	{
		alt_u32 data;

	    int itr;

	    IOWR( F_ENGINE_BASE , CX_REG , (alt_u32) cx);
	    IOWR( F_ENGINE_BASE, CY_REG , (alt_u32) cy);
	    IOWR( F_ENGINE_BASE , MAX_ITR_REG, (alt_u32) max_itr);
	    IOWR( F_ENGINE_BASE, FRAC_START_REG, 0);

	    while(1)
	    {
	    	data=IORD(F_ENGINE_BASE, ITR_DATA_REG);
	    	if(data & FRAC_READY_BIT)
	    		break;
	    }

	    itr= data& ITR_FIELD;

	    return(itr);



	}







int assign_color(int iter,int max_iter )
{
	int p;
	int color;

	if(iter==max_iter)
	{
		color=0x0000;
	}
	else
	{
		p=iter%80;
		color=colors[p];

	}


	return(color);

}


fixed428 botoncx()
{
	 fixed428 cxx;

	 cxx=0;

	if(	UP_snes_event_up())
	{

		cxx=cxx+0;

	}
	else if(	DOWN_snes_event_up())
	{
		cxx=cxx+0;
	}
	else if(	LEFT_snes_event_up())
	{
		cxx=cxx-0x00000010;
	}
	else if(	RIGHT_snes_event_up())
		{
			cxx=cxx+0x00000010;
		}
	else if		(X_snes_event_up()) // zoom in
		{
			cxx=cxx+0x00000010;
		}

	else if		(Y_snes()) // zoom out
			{
			cxx=cxx-0x00000010;
			}
	else
	{
		cxx=cxx+0;

	}

	return cxx;

}


fixed428 botoncy()
{
	fixed428 cyy;
	cyy=0;

	if(	UP_snes_event_up())
	{
		cyy=cyy+0x00000010;
	}
	else if(	DOWN_snes_event_up())
	{
		cyy=cyy-0x00000010;
	}
	else if(	LEFT_snes_event_up())
	{
		cyy=cyy+0;
	}
	else if(	RIGHT_snes_event_up())
		{
		cyy=cyy+0;
		}
	else if		(X_snes_event_up())
			{

		cyy=cyy+0x00000010;

			}

	else if		(Y_snes())
			{

		cyy=cyy-0x00000010;
			}
	else
	{
		cyy=cyy+0;
	}

	return cyy;

}

fixed428 botonxn()
{
	fixed428 xnn;
	xnn=0;

	if(	UP_snes_event_up())
	{
		xnn= xnn+0;
	}
	else if(	DOWN_snes_event_up())
	{
		xnn= xnn+0;
	}
	else if(	LEFT_snes_event_up())
	{
		xnn= xnn-0x00000010;
	}
	else if(	RIGHT_snes_event_up())
		{
		xnn= xnn+0x00000010;
		}
	else if		(X_snes_event_up())
			{
		xnn= xnn-0x00000010;
			}

	else if		(Y_snes())
			{
		xnn= xnn+0x00000010;
			}
	else
	{
		xnn=xnn+0;
	}

	return xnn;

}

fixed428 botonyn()
{
	fixed428 ynn;
ynn=0;
	if(	UP_snes_event_up())
	{
		ynn=ynn+0x00000010;
	}
	else if(	DOWN_snes_event_up())
	{
		ynn=ynn-0x00000010;
	}
	else if(	LEFT_snes_event_up())
	{
		ynn=ynn+0;
	}
	else if(	RIGHT_snes_event_up())
		{

		ynn=ynn+0;

		}

	else if		(X_snes_event_up())
			{
		ynn=ynn-0x00000010;
			}

	else if		(Y_snes())
			{
		ynn=ynn+0x00000010;
			}
	else
	{
		ynn=ynn+0;
	}
	return ynn;

}


int main(){


//***** INICIALIZANDO DRIVERS ****//


	// init Touch
	int result;
		int event=0;
		int pos_x,pos_y;
		alt_touchscreen touchscreen_global;


		result=alt_touchscreen_init(
	    &touchscreen_global,
	    TOUCH_PANEL_SPI_BASE,
	    TOUCH_PANEL_SPI_IRQ,
	    TOUCH_PANEL_PENIRQ_N_BASE,
	    60,
	    ALT_TOUCHSCREEN_SWAP_XY);

		if(result==0){
			printf("Touch Inicializado\n");

			alt_touchscreen_calibrate_upper_right (&touchscreen_global,
				 3975,   4032,    // ADC readings
				  479,      0  ); // pixel coords
			alt_touchscreen_calibrate_lower_left  (&touchscreen_global,
				 112,    110,     // ADC readings
				   0,    271  );  // pixel coords
		}
		else{

			printf("Touch Fallo\n");
			return 0;
		}

// init video

	  VIP_FRAME_READER *pReader;

	    ////////Se inicializa el HW del sistema//////////////
	    // frame reader

	    pReader =  VIPFR_Init(ALT_VIP_VFR_0_BASE, (void *)FR_FRAME_0, (void *)FR_FRAME_1, FRAME_WIDTH, FRAME_HEIGHT);

	   // se activa el frame de video
	    VIPFR_ActiveDrawFrame(pReader);
	    // clean screen
	    vid_clean_screen(pReader, BLACK_24);
	   // se activa el frame de video
		VIPFR_ActiveDrawFrame(pReader);
		// clean screen
		vid_clean_screen(pReader, BLACK_24);



	    printf("Video Inicializado\n");


	    //***** PROGRAMA PRINCIPAL ****//
		   fixed428 cy;
		   fixed428 cy01;
		   fixed428 cx01;
		   fixed428 cy0;
		   fixed428 cx0;

		   fixed428 cx;
		   int j;
		   int i;
		   int HPIX;
		   int VPIX;
		   fixed428 deltax;
		   fixed428 deltay;
		   int itr;
		   alt_u16 max_itr;
		   int color;
		   fixed428 xn1;
		   fixed428 yn1;

		   fixed428 xn;
		   fixed428 yn;

		   // resolucin de la pantalla

		   // Area de dibujo del fractal
		   cx0=0xe0000000 ;
		   cy0=0xf0000000;
		   xn=0x10000000;
		   yn=0x10000000;




		  // clculo de delta
		   max_itr=100;
		   HPIX=480;
		   VPIX=272;


		   int start;
		   start=1;

		   int addr;
		   char text[100];

		   fixed428 incx=1;
		   char draw=10;
	    	while(1){

	    		if(IORD(BOTON_UP_BASE,0)==1){
	    			cy0=cy0+0x04000000;
	    			yn=yn+0x04000000;
	    			draw++;

	    		}
	    		else if(IORD(BOTON_DOWN_BASE,0)==1){
	    			cy0=cy0-0x04000000;
					yn=yn-0x04000000;
					draw++;
	    		}


	    		if(IORD(BOTON_RIGHT_BASE,0)==1){
	    			cx0=cx0+0x04000000;
	    			xn=xn+0x04000000;
	    			draw++;

	    		}
	    		else if(IORD(BOTON_LEFT_BASE,0)==1){
	    			cx0=cx0-0x04000000;
					xn=xn-0x04000000;
					draw++;
	    		}


	    		if(IORD(BOTON_Y_BASE,0)==1){
	    			cx0=cx0+0x00200000;
					xn=xn-0x00200000;
					cy0=cy0+0x00200000;
					yn=yn-0x00200000;
					draw++;
	    		}

	    		if(IORD(BOTON_X_BASE,0)==1){
	    			cx0=cx0-0x00200000;
					xn=xn+0x00200000;
					cy0=cy0-0x00200000;
					yn=yn+0x00200000;
					draw++;
				}

	    		deltax=( fixed428)(xn-cx0)/HPIX;
				deltay=( fixed428)(yn-cy0)/HPIX;

				if(draw>=10){
					cy = cy0;
					for(j=0; j<VPIX; j++){

							cx = cx0;
							for(i=0; i<HPIX; i++){
								itr = calc_frac_point_hw (cx , cy, max_itr);

								color = assign_color(itr,max_itr);
								//vid_set_pixel(i,j,color,pReader);
								addr = ( ( (int)(VIPFR_GetDrawFrame(pReader)) )+ (j * (pReader->width * 4)) + i * 4);
								IOWR_32DIRECT( addr, 0, (unsigned int)(color));
								cx = cx + deltax;



								}
							cy = cy + deltay;



					}

					sprintf(text,"itr=%d",max_itr);
					vid_print_string(10, 10, BLACK_24, cour10_font, pReader, text);
					//max_itr+=10;
					VIPFR_ActiveDrawFrame(pReader);

					draw=0;

				}


		}


	return 0;
}


